﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Editors;
using System.Collections.Specialized;
using System.Windows.Interactivity;
using System.Collections;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace Silverlight20103Demos.Views.ComboEditor
{
    public partial class SelectedItemsBehaviorDemo : UserControl
    {
        public SelectedItemsBehaviorDemo()
        {
            InitializeComponent();
        }
    }

    public class SelectedItemsBehaviorDemoViewModel
    {
        ObservableCollection<SelectedItemsBehaviorDemoData> _data = new ObservableCollection<SelectedItemsBehaviorDemoData>();
        ObservableCollection<SelectedItemsBehaviorDemoData> _selecteddata = new ObservableCollection<SelectedItemsBehaviorDemoData>();

        public SelectedItemsBehaviorDemoViewModel()
        {
            _data.Add(new SelectedItemsBehaviorDemoData() { Name = "A" });
            _data.Add(new SelectedItemsBehaviorDemoData() { Name = "B" });
            _data.Add(new SelectedItemsBehaviorDemoData() { Name = "C" });
            _data.Add(new SelectedItemsBehaviorDemoData() { Name = "D" });
            _data.Add(new SelectedItemsBehaviorDemoData() { Name = "E" });
            _data.Add(new SelectedItemsBehaviorDemoData() { Name = "F" });
            _data.Add(new SelectedItemsBehaviorDemoData() { Name = "G" });
            _data.Add(new SelectedItemsBehaviorDemoData() { Name = "H" });
        }

        public ObservableCollection<SelectedItemsBehaviorDemoData> Data { get { return _data; } }

        public ObservableCollection<SelectedItemsBehaviorDemoData> SelectedData { get { return _selecteddata; } }

        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class SelectedItemsBehaviorDemoData
    {
        public string Name { get; set; }
    }

    public class XamComboEditorSelectedItemsBehavior : Behavior<XamComboEditor>
    {
        private XamComboEditor Combobox
        {
            get
            {
                return AssociatedObject as XamComboEditor;
            }
        }

        public INotifyCollectionChanged SelectedItems
        {
            get { return (INotifyCollectionChanged)GetValue(SelectedItemsProperty); }
            set { SetValue(SelectedItemsProperty, value); }
        }

        public static readonly DependencyProperty SelectedItemsProperty =
            DependencyProperty.Register("SelectedItems", typeof(INotifyCollectionChanged), typeof(XamComboEditorSelectedItemsBehavior), new PropertyMetadata(OnSelectedItemsPropertyChanged));


        private static void OnSelectedItemsPropertyChanged(DependencyObject target, DependencyPropertyChangedEventArgs args)
        {
            var collection = args.NewValue as INotifyCollectionChanged;
            if (collection != null)
            {
                collection.CollectionChanged += ((XamComboEditorSelectedItemsBehavior)target).ContextSelectedItems_CollectionChanged;
            }
        }

        protected override void OnAttached()
        {
            base.OnAttached();

            Combobox.SelectedItems.CollectionChanged += new NotifyCollectionChangedEventHandler(SelectedItems_CollectionChanged);
        }

        void ContextSelectedItems_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
             UnsubscribeFromEvents();

             Transfer(SelectedItems as IList, Combobox.SelectedItems);

            SubscribeToEvents();
        }

        void SelectedItems_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            UnsubscribeFromEvents();

            Transfer(Combobox.SelectedItems, SelectedItems as IList);

            SubscribeToEvents();
        }

        private void SubscribeToEvents()
        {
            Combobox.SelectedItems.CollectionChanged += SelectedItems_CollectionChanged;

            if (SelectedItems != null)
            {
                SelectedItems.CollectionChanged += ContextSelectedItems_CollectionChanged;
            }
        }

        private void UnsubscribeFromEvents()
        {
            Combobox.SelectedItems.CollectionChanged -= SelectedItems_CollectionChanged;

            if (SelectedItems != null)
            {
                SelectedItems.CollectionChanged -= ContextSelectedItems_CollectionChanged;
            }
        }

        public static void Transfer(IList source, IList target)
        {
            if (source == null || target == null)
                return;

            target.Clear();

            foreach (var o in source)
            {
                target.Add(o);
            }
        }
    }
}
